<?php

//1. https://dev.twitter.com/apps
//2. Click "Create a new Application"
//2a. Name - the name of your website is a good one
//2b. Description - "{Your website} Twitter Feed OAuth"
//2c. Website - URL of your website
//2d. Callback URL - leave blank
//2e. Click "Create Twitter Application" button
//3. Copy Consumer & Secret Keys under OAuth settings
//4. Click "Create my access token" under "Your Access Token"
//5. Copy Access & Access Secret Tokens
//http://i.imgur.com/otatRuM.png
//6. Adjust the settings on your /twitter folder to make it writeable by the server so the tweets can be cached


//Change this to your timezone - http://www.php.net/manual/en/timezones.php
date_default_timezone_set( 'America/New_York' );
$twitter_gmt_offset				= '+5';

//YOUR TWITTER SCREENNAME
$twitter_handle					= 'your-twitter-username';

//YOUR APP'S UNIQUE KEYS
$twitter_consumer_key 			= 'your-consumer-key';
$twitter_consumer_key_secret	= 'your-consumer-key-secret';
$twitter_access_token 			= 'your-access-token';
$twitter_access_token_secret 	= 'your-access-token-secret';



//NO NEED TO EDIT BELOW THIS LINE


require_once('StormTwitter.class.php');

global $twitter;

if( !$twitter ){

	$config = array(
	  'directory' => 'twitter/', //The path used to store the .tweetcache cache file.
	  'key' => $twitter_consumer_key,
	  'secret' => $twitter_consumer_key_secret,
	  'token' => $twitter_access_token,
	  'token_secret' => $twitter_access_token_secret,
	  'cache_expire' => 3600 //The duration of the cache  
	);

	$twitter = new StormTwitter( $config );
}

function agility_twitter_feed( $twitterhandle, $numTweets = 1 , $twitter_gmt_offset = '+5' ){

	global $twitter, $twitter_gmt_offset;
 
	$tweets = $twitter->getTweets( $numTweets , $twitterhandle , array( 'exclude_replies'=>true ) );//change number up to 20 for number of tweets
						
	if( is_array( $tweets ) ){	

		if( isset( $tweets['error'] ) ){
			if( current_user_can( 'edit_posts' ) ){
				echo 'Twitter feed unavailable.  ' . $tweets['error'];
			}
			else{
				echo 'Twitter feed unavailable.';
			}
			return;
		}

		echo '<ul>';
		
		foreach( $tweets as $tweet ){
			//ssd( $tweet );
			$the_tweet = $tweet['text'];

			// i. User_mentions must link to the mentioned user's profile.
			if(is_array($tweet['entities']['user_mentions'])){
				foreach($tweet['entities']['user_mentions'] as $key => $user_mention){
					$the_tweet = preg_replace(
						'/@'.$user_mention['screen_name'].'/i',
						'<a href="http://www.twitter.com/'.$user_mention['screen_name'].'" target="_blank">@'.$user_mention['screen_name'].'</a>',
						$the_tweet);
				}
			}

			// ii. Hashtags must link to a twitter.com search with the hashtag as the query.
			if(is_array($tweet['entities']['hashtags'])){
				foreach($tweet['entities']['hashtags'] as $key => $hashtag){
					$the_tweet = preg_replace(
						'/#'.$hashtag['text'].'/i',
						'<a href="https://twitter.com/search?q=%23'.$hashtag['text'].'&src=hash" target="_blank">#'.$hashtag['text'].'</a>',
						$the_tweet);
				}
			}

			// iii. Links in Tweet text must be displayed using the display_url
			//      field in the URL entities API response, and link to the original t.co url field.
			if(is_array($tweet['entities']['urls'])){
				foreach($tweet['entities']['urls'] as $key => $link){
					$the_tweet = preg_replace(
						'`'.$link['url'].'`',
						'<a href="'.$link['url'].'" target="_blank">'.$link['url'].'</a>',
						$the_tweet);
				}
			}

			

			$offset_string = $twitter_gmt_offset.' hours';
			$offset_string = str_replace( '-' , ' - ' , $offset_string );
			$offset_string = str_replace( '+' , ' + ' , $offset_string );
			$tweettimestr = $tweet['created_at'] . $offset_string;
			$tweettime = strtotime( $tweettimestr );
			?> 
			<li>
				<?php echo $the_tweet; ?>
				<a href="http://twitter.com/<?php echo $twitterhandle; ?>/statuses/<?php echo $tweet['id_str']; ?>/" class="tweet-time" target="_blank"><?php echo date('h:i A M d', $tweettime  ); ?></a>
			</li>
			<?php
		}
		echo '</ul>';
	}

	
}

agility_twitter_feed( $twitter_handle );

